
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>An Introduction to Asynchronous Programming and Twisted (1) / iVAN</title>

    <meta name="description" content="An Introduction to Asynchronous Programming and Twisted (1) 之前看的时候, 总觉得思路不是很清晰, 其实Dave在这个模型问题上没有说清楚, 参考同步和异步, 阻塞和非阻塞, Reactor和Proactor 对于阻塞一定是同步的, 但是反之不一定, 对于多线程本质上也是阻塞的方式, 只不过是多个线程一起阻塞, 适用于CPU密集型的任务, 因为事情总要人做的, 无论什么模型都不能让做事情的实际时间变少.  对于非阻塞, 节省的是等待的时间, 所以适用于I/O密集型任务, 因为I/O往往需要等待  Dave谈的异步就是广义的异步, 其实是非阻塞同步  而T">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">An Introduction to Asynchronous Programming and Twisted (1)</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>之前看的时候, 总觉得思路不是很清晰, 其实Dave在这个模型问题上没有说清楚, 参考<a href="http://www.cnblogs.com/fxjwind/archive/2013/05/25/3099061.html" rel="external nofollow noreferrer">同步和异步, 阻塞和非阻塞, Reactor和Proactor</a></p>
<p>对于阻塞一定是同步的, 但是反之不一定, 对于多线程本质上也是阻塞的方式, 只不过是多个线程一起阻塞, 适用于CPU密集型的任务, 因为事情总要人做的, 无论什么模型都不能让做事情的实际时间变少. <br />
对于非阻塞, 节省的是等待的时间, 所以适用于I/O密集型任务, 因为I/O往往需要等待 <br />
Dave谈的异步就是广义的异步, 其实是非阻塞同步 <br />
而Twisted解决的问题就是非阻塞同步问题, 即Reactor模型, 更进一步就是使用select, poll, epoll等系统调用监控一组I/O, 并通知应用端的demultiplexor(扮演Reactor角色)</p>
<p>而真正的非阻塞异步, 由于需要操作系统特别的支持, 其实很少被真正使用, 因为Unix并不支持...</p>
<p>Twisted解决什么问题? <br />
提供一种基于Reactor模型的编程框架, 对socket和select做封装, 让用户只需要通过定义callback和Defered就可以实现 <br />
但需要明白的是, 他能够做的事情和使用底层socket, select去实现的版本没有区别, 没有特别神奇的... <br />
Twisetd的封装做的确实非常好, 我觉得学习他的最大好处是体会封装的思路, 从底层的socket,select –&gt; Reactor –&gt; Protocol, Transport –&gt; Callback –&gt; Defered <br />
但问题也在这儿, 封装太多, 导致如果直接使用, 你会不知道你自己到达在干什么, 会很疑惑, 导致学习成本和曲线比较高 <br />
如果我学习socket和select, 比学习Twisted更容易的话, 我为什么要去学习Twisted, 毕竟使用者都是程序员, 而不是最终不懂code的用户 </p>
<p><a href="http://krondo.com/?page_id=1327" rel="external nofollow noreferrer">http://krondo.com/?page_id=1327</a>  Twisted Introduction (Dave Peticolas) <br /><a href="http://blog.sina.com.cn/s/blog_704b6af70100py9n.html" rel="external nofollow noreferrer">http://blog.sina.com.cn/s/blog_704b6af70100py9n.html</a>  中文</p>
<p> </p>
<h2>Part 1: In Which We Begin at the Beginning</h2>
<h3>Preface</h3>
<p>Twisted is a highly abstracted system and this gives you tremendous leverage when you use it to solve problems. But when you are learning Twisted, and particularly when you are trying to understand how Twisted actually works, the many levels of abstraction can cause troubles. <br />
Much of the challenge does not stem from Twisted per se, but rather in the acquisition of the “mental model” required to write and understand asynchronous code.</p>
<p><u>Twisted挺难学和理解的, 这个不是来自他本身, Twisted本身的代码和文档都是写的不错的, 主要因为大家缺乏这个mental model. 所以下面来讲这个models.</u></p>
<h3>The Models</h3>
<p>The first model we will look at is the single-threaded synchronous model, in Figure 1 below:</p>
<p><a href="http://images.cnitblog.com/blog/312753/201305/27162436-b61d4108ae0f4fdba2e3ac1fd718198d.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzMxMjc1My8yMDEzMDUvMjcxNjI0MzYtNDY3NTAwMWYwZmQ0NDFjM2IyOTEyN2Y1OGMyY2YyZGIucG5n.jpg"></a></p>
<p>We can contrast the synchronous model with another one, the <strong>threaded model</strong> illustrated in Figure 2:</p>
<p><a href="http://images.cnitblog.com/blog/312753/201305/27162437-36829a449a0c4e38810580473a1e0861.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzMxMjc1My8yMDEzMDUvMjcxNjI0MzctOGNkZWM4MmJmMjUwNGQxYWJkNGExNzIxZmNmNjY4NzMucG5n.jpg"></a></p>
<p>The threads are managed by the operating system and may, on a system with multiple processors or multiple cores, run truly concurrently, or may be interleaved together on a single processor. The point is, in the threaded model the details of execution are <strong>handled by the OS</strong> and the programmer simply thinks in terms of independent instruction streams which may run simultaneously. <strong>Thread communication and coordination</strong> is an advanced programming topic and can be <strong>difficult</strong> to get right.</p>
<p>Now we can introduce the <strong>asynchronous model</strong> in Figure 3:</p>
<p><a href="http://images.cnitblog.com/blog/312753/201305/27162437-8ec3651ce6f44dffad85c5645e23fa46.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzMxMjc1My8yMDEzMDUvMjcxNjI0MzctNGJiMWIwOWYxZTI0NDNkODkzYzdhMTNhY2Y5MjFjZmIucG5n.jpg"></a></p>
<p><strong>Differences</strong> between the asynchronous and threaded models: <br />
In asynchronous model, the tasks are <strong>interleaved</strong> with one another, but in a <strong>single thread of control</strong> . This is simpler than the threaded case because the <strong>programmer</strong> always knows that when one task is executing, another task is not. <br /><u>对于异步模式, 任务是必定会被<strong>interleave</strong> 成多个任务片段的, 但是这些interleave是在<strong>single thread</strong> 中被执行的, 所以不存在多个interleave都是run的情况, 这里就不用考虑多线程的同步和通信的问题 (这个问题往往是比较复杂的). 并且interleave的切换是用<strong>programmer</strong> 控制的.</u></p>
<p><u>In threaded model, 任务也有可能会被<strong>interleaved</strong> (单核cup), 但对于multi-cup, 就不会被interleaved, 这才是真正的threaded model. 并且多个任务是同时执行的, 必须考虑同步和通信问题. 最后任务的切换和调度是又<strong>OS</strong> 决定的, programmer管不了.</u></p>
<h3>The Motivation</h3>
<p>We’ve seen that the asynchronous model is simpler than the threaded one because there is <strong>a single instruction stream</strong>and <strong>tasks explicitly relinquish control</strong> instead of being suspended arbitrarily. But the asynchronous model is clearly more complex than the synchronous case. Since there is no actual parallelism, it appears from our diagrams that an asynchronous program will take just as long to execute as a synchronous one, perhaps longer as the asynchronous program might exhibit poorer <a href="http://en.wikipedia.org/wiki/Locality_of_reference" rel="external nofollow noreferrer">locality of reference</a> .</p>
<p><u>异步模式因为是单条指令流和任务用户可控, 所以比线程模式简单. 但他明显比阻塞模式复杂, 更长实际执行时间, 更差的locality of reference.<br />
那么我们为什么要用异步模式?</u></p>
<p>Compared to the synchronous model, the asynchronous model performs best when:</p>
<ol>
<li>There are a large number of tasks so there is likely always at least one task that can make progress.</li>
<li>The tasks perform <strong>lots of I/O</strong> , causing a synchronous program to waste lots of time blocking when other tasks could be running.</li>
<li>The tasks are largely independent from one another so there is <strong>little</strong> need for <strong>inter-task communication</strong> (and thus for one task to wait upon another).</li>
</ol>
<p>These conditions almost perfectly characterize a <strong>typical busy network server</strong> (like a web server) in a client-server environment. Each task represents one client request with I/O in the form of receiving the request and sending the reply. And client requests (being mostly reads) are largely independent. So a network server implementation is a prime candidate for the asynchronous model and this is why Twisted is first and foremost a networking library.</p>
<p><u>象我前篇写的, 其实I/O bound比较适合异步, CPU bound比较适合线程. 所以异步模式最适合的场景就是Web server, 需要同时处理多个client requests, 每个request相对独立, 大量的I/O操作.</u></p>
<p><u></u></p>
<h2>Part 2: Slow Poetry and the Apocalypse</h2>
<p>这章会用基本的python socket模块来编写同步和异步模式, 这样能更好的理解reactor设计模式.</p>
<h3>Slow Poetry</h3>
<p>实现一个提供poetry服务的服务器, 当你访问就返回给你某首诗. 为了能看到过程中间加了sleep, 所以是slow poetry.</p>
<p>首先是block的server, <a href="http://github.com/jdavisp3/twisted-intro/blob/master/blocking-server/slowpoetry.py" rel="external nofollow noreferrer">blocking-server/slowpoetry.py</a> </p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<pre>
</pre>
<p>1 sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)<br />2     sock.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)<br />3     sock.bind((options.iface, options.port or 0))<br />4     sock.listen(5)<br />5     while True:<br />6         sock, addr = listen_socket.accept()<br />7         send_poetry(sock, poetry_file, num_bytes, delay)</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<p>    <br />
<br />典型的block server, bind到一个端口, listen该端口(系统会开线程侦听该端口, connection队列上限设为5) <br />
在循环中, 不断用accept取得connection, 并且处理, 这儿就是发送poetry</p>
<h3>The Blocking Client</h3>
<p>Now we can use the blocking client in <a href="http://github.com/jdavisp3/twisted-intro/blob/master/blocking-client/get-poetry.py" rel="external nofollow noreferrer">blocking-client/get-poetry.py</a></p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<pre>
</pre>
<p>1 for i, address in enumerate(addresses):<br />2     sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)<br />3     sock.connect(address)<br />4     while True:<br />5         bytes = sock.recv(1024)<br />6         if not bytes:<br />7             sock.close()<br />8             break<br />9         poem += bytes</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<p>典型的block client, 如果对于多个服务器, one by one, connect, 一直读到读不到数据, 然后再处理下个服务器. 这个体现了Part1里面的<strong>synchronous model</strong> .</p>
<h3>The Asynchronous Client</h3>
<p>Now let’s take a look at a simple asynchronous client written without Twisted, in <a href="http://github.com/jdavisp3/twisted-intro/blob/master/async-client/get-poetry.py" rel="external nofollow noreferrer">async-client/get-poetry.py</a></p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<pre>
</pre>
<p>1 sockets = map(connect, addresses)<br /> 2     while sockets:<br /> 3         # this select call blocks until one or more of the<br /> 4          # sockets is ready for read I/O<br /> 5          rlist, _, _ = select.select(sockets, [], [])  # rlist is the list of sockets with data ready to read<br /> 6          for sock in rlist:<br /> 7             bytes = ''<br /> 8             while True:<br /> 9                 try:<br />10                     bytes += sock.recv(1024)<br />11                     if not bytes:<br />12                         break<br />13                 except socket.error, e:<br />14                     if e.args[0] == errno.EWOULDBLOCK:<br />15                         # this error code means we would have<br />16                          # blocked if the socket was blocking.<br />17                         # instead we skip to the next socket<br />18                         break<br />19                     raise<br />20             if not bytes:<br />21                 sockets.remove(sock)<br />22                 sock.close()<br />23             poems[sock] += bytes</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<p>先同时connect上多个端口, 过程和block一样, 只不过需要sock.setblocking(0), 将socket设为异步. <br />
然后最关键的就是对<strong>select.select</strong> 的调用, 这个函数详细参见前篇. 这个也是对Twisted的模拟, 都是通过select, poll系统调用来完成对多个端口的异步侦听. <br />
后面的逻辑, 就是一次有多少读多少, 然后继续侦听, 一直到读完为止...</p>
<p>The <strong>core</strong> of the <strong>asynchronous client</strong> is the <strong>top-level loop</strong> . This loop can be broken down into steps:</p>
<ol>
<li>Wait (block) on all open sockets using <code>select</code> until one (or more) sockets has data to be read.</li>
<li>For each socket with data to be read, read it, but only as much as is available now. <a href="http://en.wikipedia.org/wiki/Asynchronous_I/O" rel="external nofollow noreferrer">Don’t block</a> .</li>
<li>Repeat, until all sockets have been closed.</li>
</ol>
<p>同时侦听多个端口, 哪个端口有数据, 就先处理哪一个, 有多少数据就处理多少, 这个体现了Don't block. 这个体现了Part1里面的<strong>asynchronous model.</strong></p>
<h3>Reactor Pattern</h3>
<p>This use of a loop which waits for events to happen, and then handles them, is so common that it has achieved the status of a design pattern: the <a href="http://en.wikipedia.org/wiki/Reactor_pattern" rel="external nofollow noreferrer">reactor pattern</a> .</p>
<p><a href="http://images.cnitblog.com/blog/312753/201305/27162438-57c934b4ad6449ec802375596b0866e9.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzMxMjc1My8yMDEzMDUvMjcxNjI0MzgtZGQ2NDg5YmRiMzE3NGI4YTg3Mzk0MWU1NzAyOTg0OTkucG5n.jpg"></a></p>
<p>The loop is a “reactor” because it waits for and then reacts to events. For that reason it is also known as an <em><strong>event loop</strong></em> . And since reactive systems are often waiting on I/O, these loops are also sometimes called <a href="http://en.wikipedia.org/wiki/Asynchronous_I/O#Select.28.2Fpoll.29_loops" rel="external nofollow noreferrer"><em><strong>select loops</strong></em></a> , since the select call is used to wait for I/O.</p>
<p>A real implementation of the reactor pattern would implement the loop as a separate abstraction with the ability to:</p>
<ol>
<li>Accept a set of file descriptors you are interested in performing I/O with.</li>
<li>Tell you, repeatedly, when any file descriptors are ready for I/O.</li>
</ol>
<p>And a really good implementation of the reactor pattern would also:</p>
<ol>
<li>Handle all the weird corner cases that crop up on different systems.</li>
<li>Provide lots of nice abstractions to help you use the reactor with the least amount of effort.</li>
<li>Provide implementations of public protocols that you can use out of the box.</li>
</ol>
<p>Well that's just what Twisted is — a robust, cross-platform implementation of the Reactor Pattern with lots of extras.</p>
<p> </p>
<h2>Part 3: Our Eye-beams Begin to Twist</h2>
<h3>Doing Nothing, the Twisted Way</h3>
<p>The absolute simplest Twisted program is listed below, and is also available in <a href="http://github.com/jdavisp3/twisted-intro/blob/master/basic-twisted/simple.py" rel="external nofollow noreferrer">basic-twisted/simple.py</a></p>
<p>from twisted.internet import reactor <br /><strong>reactor.run()</strong></p>
<p>Twisted is an implementation of the <a href="http://en.wikipedia.org/wiki/Reactor_pattern" rel="external nofollow noreferrer">Reactor Pattern</a> and thus contains an object that represents the reactor, or event loop, that is the heart of any Twisted program. 而run就是开启这个heart的钥匙...... <br />
This program just sits there <strong>doing nothing</strong> . Note that this is not a <a href="http://en.wikipedia.org/wiki/Busy_waiting" rel="external nofollow noreferrer">busy loop</a> which keeps cycling over and over. If you happen to have a CPU meter on your screen, you won’t see any spikes caused by this technically infinite loop. In fact, our program <strong>isn't using any CPU at all</strong> . Instead, the reactor is stuck at the top cycle of Figure 5, waiting for an event that will never come (to be specific, waiting on a <code>select</code> call with no file descriptors). 这是用select这种系统调用的最大的优点, 原因见前篇对select的介绍......</p>
<p>We're about to make it more interesting, but we can already draw a few <strong>conclusions</strong> :</p>
<ol>
<li>Twisted’s reactor loop doesn’t start until told to. You <strong>start</strong> it by calling <code><strong>reactor.run()</strong></code> .</li>
<li>The reactor loop runs in the same thread it was started in. In this case, it runs in the <strong>main (and only) thread</strong> .</li>
<li>Once the loop starts up, it just keeps going. The reactor is now “in control” of the program (or the specific thread it was started in).</li>
<li>If it doesn’t have anything to do, the <strong>reactor loop</strong> does <strong>not consume CPU</strong> .</li>
<li>The reactor isn’t created explicitly, <strong>just imported</strong> .</li>
</ol>
<p>In Twisted, the reactor is basically a <a href="http://en.wikipedia.org/wiki/Singleton_pattern" rel="external nofollow noreferrer">Singleton</a> . There is only one reactor object and it is created implicitly when you import it. If you open the <a href="http://twistedmatrix.com/trac/browser/tags/releases/twisted-8.2.0/twisted/internet/reactor.py" rel="external nofollow noreferrer"><code>reactor</code></a> module in the <code>twisted.internet</code> package you will find very little code. The actual implementation resides in other files (starting with <a href="http://twistedmatrix.com/trac/browser/tags/releases/twisted-8.2.0/twisted/internet/selectreactor.py" rel="external nofollow noreferrer"><code>twisted.internet.selectreactor</code></a> ). <br />
当然除了select, 还有其他的reactor, 选择的依据和切换方法参见<a href="http://twistedmatrix.com/documents/current/core/howto/choosing-reactor.html" rel="external nofollow noreferrer">http://twistedmatrix.com/documents/current/core/howto/choosing-reactor.html</a></p>
<h3>Hello, Twisted</h3>
<p>Let's make a Twisted program that at least does <em>something</em> .</p>
<p>from twisted.internet import reactor <br />
reactor.callWhenRunning(hello) <br />
reactor.run()</p>
<p><u>这个在上面的例子里面加了一行代码, 为WhenRunning事件定义一个callback 'hello', 这儿只是注册callback, 不会真正执行hello. <br />
当调用run()以后, 触发WhenRunning事件, reactor捕捉到该事件后会调用已注册的callback 'hello' <br /></u>We use the term <em>callback</em> to describe the reference to the <code>hello</code> function. A callback is a function reference that we give to Twisted (or any other framework) that Twisted will use to “call us back” at the appropriate time, in this case right after the reactor loop starts up.</p>
<p>Twisted is not the only reactor framework that uses callbacks. The older asynchronous Python frameworks <a href="http://www.nightmare.com/medusa/" rel="external nofollow noreferrer">Medusa</a> and<a href="http://docs.python.org/library/asyncore.html#module-asyncore" rel="external nofollow noreferrer">asyncore</a> also use them. As do the GUI toolkits <a href="http://gtk.org/" rel="external nofollow noreferrer">GTK</a> and <a href="http://qt.nokia.com/" rel="external nofollow noreferrer">QT</a> , both based, like many GUI frameworks, on a reactor loop. <br />
reactor和callback是一种典型的异步设计模式, 被用于很多异步framework, Twisted只是其中之一</p>
<p>Figure 6 shows what happens during a callback:</p>
<p><a href="http://images.cnitblog.com/blog/312753/201305/27162438-8071c524e4074e95a5dcf6ed9dff2721.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzMxMjc1My8yMDEzMDUvMjcxNjI0MzgtMGI0MzM0ZTZiYjU1NDE0ODhjYjdmOThmMzUyYmI5NDEucG5n.jpg"></a></p>
<p>Figure 6 illustrates some important properties of callbacks:</p>
<ol>
<li>Our <strong>callback code</strong> runs in the <strong>same thread</strong> as the <strong>Twisted loop</strong> .</li>
<li>When our callbacks are running, the Twisted loop is not running.</li>
<li>And vice versa.</li>
<li>The reactor loop resumes when our callback returns.</li>
</ol>
<p>During a callback, the Twisted loop is effectively “blocked” on our code. So we should make sure our callback code doesn’t waste any time. <br /><u>这个图强调了只有一个thread, 执行callback的时候就无法监听event  <br />
并且Reactor Loop和callback(bussiness logic)是分离的, Twisted只负责Reactor部分, bussiness logic用户必须通过callback的形式来实现 <br />
由于Twisted Loop是被'blocked', 当我们在执行callback时, 所以必须保证callback不浪费任何时间, 而且这一点必须由用户(callback编写者)来保证</u></p>
<p><u>实际情况中, 不可能所有的callback都马上返回的, I/O操作, 文件读写, 数据库访问等等都是很耗时的, 肿么办...... <br />
Twisted提供了很多异步API用于封装这些耗时的操作, 你通过调用Twisted API就可以较好的解决这个问题, 具体后面会讨论.</u></p>
<h3>Goodbye, Twisted</h3>
<p>It turns out you can tell the Twisted reactor to stop running by using the reactor's <code>stop</code> method. But once stopped the reactor cannot be restarted, so it’s generally something you do only when your program needs to exit.</p>
<p><u>这节更重要的是讲了calllater的用法, reactor.callLater(<code>1</code> <code>,</code> <code>self</code> </u><code><u>.count) <br /></u></code>This program uses the <code>callLater</code> API to register a callback with Twisted. With <code>callLater</code> the callback is the second argument and the first argument is the number of seconds in the future you would like your callback to run.</p>
<p>So how does Twisted arrange to execute the callback at the right time? <br /><u>这是个自然的问题, reactor loop监控一组file descriptors, 并产生相应的事件. 那么怎样触发这种'几秒之后'的事件了. <br /></u>答案, The <code>select</code> call, and the others like it, also accepts an optional <em>timeout</em> value. If a timeout value is supplied and no file descriptors have become ready for I/O within the specified time then the <code>select</code> call will return anyway. You can think of a<strong>timeout</strong> as another <strong>kind of event</strong> the event loop of <a href="http://krondo.com/blog/?p=1247#figure5" rel="external nofollow noreferrer">Figure 5</a> is waiting for. And Twisted uses timeouts to make sure any “timed callbacks” registered with <code>callLater</code> get called at the right time. <br /><u>就是说select的timeout本身也是event, reactor捕捉到这个timeout event就会去check, 当前时间是否有timed callbacks需要被触发. 我的疑问是那么这个timeout应该设多少, 应该不能设一个定值, 难道是设成最近的calllater需要触发的时间和当前时间的差值......</u></p>
<p>Twisted’s <code>callLater</code> mechanism cannot provide the sort of guarantees required in a <a href="http://en.wikipedia.org/wiki/Real-time_computing#Hard_and_soft_real-time_systems" rel="external nofollow noreferrer">hard real-time</a> system. <br /><u>而且这个calllater只是个近似的, 不能确保这个function在n秒后被执行,</u>  If another callback takes a really long time to execute, a timed callback may be delayed past its schedule.</p>
<h3>Take That, Twisted</h3>
<p>Since Twisted often ends up calling our code in the form of callbacks, you might wonder what happens when a callback raises an exception. <br />
答案是, 你不用怕, callback的异常不会导致twisted loop的crash, twsited会print出错误, 并继续执行. 这个是理所当然的......</p>
<p> </p>
<h2>Part 4: Twisted Poetry</h2>
<h3>Our First Twisted Client</h3>
<p>Although Twisted is probably more often used to write servers, clients are simpler than servers and we’re starting out as simply as possible. Let’s try out our first poetry client written with Twisted. The source code is in <a href="http://github.com/jdavisp3/twisted-intro/blob/master/twisted-client-1/get-poetry.py" rel="external nofollow noreferrer">twisted-client-1/get-poetry.py</a> . <br /><u>这个例子是和上面的<strong>asynchronous client</strong> 实现完全相同的功能, 只不过是用low-level的twisted API进行一步封装, 为了深入浅出的理解twisted, 所以先用low-level的封装, 后面再用high-level的API.</u></p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<pre>
</pre>
<p>1 sockets = [PoetrySocket(i + 1, addr) for i, addr in enumerate(addresses)]<br /> 2 from twisted.internet import reactor<br /> 3 reactor.run()<br /> 4 class PoetrySocket(object):<br /> 5     poem = ''<br /> 6     def __init__(self, task_num, address):<br /> 7         self.task_num = task_num<br /> 8         self.address = address<br /> 9         self.sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)<br />10         self.sock.connect(address)<br />11         #self.sock.setblocking(0) we don't set non-blocking -- broken!<br />12         # tell the Twisted reactor to monitor this socket for reading<br />13         from twisted.internet import reactor<br />14         reactor.addReader(self)<br />15     def connectionLost(self, reason):<br />16         self.sock.close()<br />17         # stop monitoring this socket<br />18         from twisted.internet import reactor<br />19         reactor.removeReader(self)<br />20         # see if there are any poetry sockets left<br />21         for reader in reactor.getReaders():<br />22             if isinstance(reader, PoetrySocket):<br />23                 return<br />24         reactor.stop() # no more poetry<br />25     def doRead(self):<br />26         poem = ''<br />27         while True: # we're just reading everything (blocking) -- broken!<br />28             bytes = self.sock.recv(1024)<br />29             if not bytes:<br />30                 break<br />31             poem += bytes<br />32         msg = 'Task %d: got %d bytes of poetry from %s'<br />33         print  msg % (self.task_num, len(poem), self.format_addr())<br />34         self.poem = poem<br />35         return main.CONNECTION_DONE</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<p><u>可以先去回顾一下上面<strong>asynchronous client</strong> 的代码, 核心的步骤有3个, <br />
1. 建立到各个server的socket connections, 在PoetrySocket.__init__()中实现 <br />
2. select loop同时侦听所有sockets端口, 返回有数据的端口, 没有直接实现, 被reactor封装了 <br />
3. 处理数据, 当发现数据接受完毕关闭socket, 在PoetrySocket.doRead()和connectionLost()中实现 <br />
可见Twisted通过reactor封装了select loop和事件触发callback函数的过程, 程序员只需要使用reactor.addReader(self)将提供callback函数如doRead的对象注册到reactor中, 就可以简单的完成<strong>asynchronous client</strong></u></p>
<h3>Twisted Interfaces</h3>
<p>There are a number of sub-modules in Twisted called <code>interfaces</code> . Each one defines a set of <code>Interface</code> classes. As of version 8.0, Twisted uses <code><a href="http://www.zope.org/Products/ZopeInterface" rel="external nofollow noreferrer">zope.interface</a></code> as the basis for those classes, but the details of that package aren't so important for us. We're just concerned with the Interface sub-classes in Twisted itself, like the ones you are looking at now.</p>
<p>One of the principle purposes of Interfaces is <strong>documentation</strong> . As a Python programmer you are doubtless familiar with<a href="http://en.wikipedia.org/wiki/Duck_typing" rel="external nofollow noreferrer">Duck Typing</a> , the notion that the <strong>type of an object</strong> is principally defined not by its position in a class hierarchy but by the<strong>public interface it presents</strong> to the world. Thus two objects which present the same public interface (i.e., walk like a duck, quack like a …) are, as far as duck typing is concerned, the same sort of thing (a duck!). Well an Interface is a somewhat formalized way of specifying just what it means to walk like a duck.</p>
<p><u>如果要理解Twisted封装, 必须首先了解这个zope.interface (</u><a href="http://apidoc.zope.org/++apidoc++/Book/ifaceschema/interface/show.html" rel="external nofollow noreferrer">http://apidoc.zope.org/++apidoc++/Book/ifaceschema/interface/show.html</a><u> ), 这儿没详细说, 感兴趣的可以去研究一下. <br />
其实对于Java和C++这种强类型语言, 对象的Type完全取决于class hierarchy 的位置, 不能随意改变的. 但对于Python这样的语言, 类接口在运行时, 是可以动态改变的, 所以无法定死对象的类型, 于是有Duck Typing的说法, 就是说你现在的接口看起来象个鸭子, 那我们就认为你现在属于鸭子类.   <br />
同时Zope定义的interface和python官方的ABC(抽象基类)很相似, 那么有人比较了两者认为interface好些, Explaining Why Interfaces Are Great, </u><a href="http://glyph.twistedmatrix.com/2009/02/explaining-why-interfaces-are-great.html" rel="external nofollow noreferrer">http://glyph.twistedmatrix.com/2009/02/explaining-why-interfaces-are-great.html</a><u> , 有兴趣的可以自己看看, 这儿就摘录了总结, 如下 <br /></u>In a super-dynamic language like Python, you don't <em>need</em> a system for explicit abstract interfaces.  No compiler is going to shoot you for calling a 'foo' method.  But, formal interface definitions serve many purposes.  They can function as<strong>documentation</strong> , as a <strong>touchstone for code</strong> which wants to clearly report programming errors ("warning:  MyWidget claims to implement IWidget, but doesn't implement a 'doWidgetStuff' method"), and a <strong>mechanism for indirection</strong> when you know what contract your code wants but you don't know what implementation will necessarily satisfy it (<strong>adaptation</strong> ). <br />
上面说了对于python这样的动态的(弱类型的)语言, 似乎并不需要这样的一个explicit abstract interfaces, 因为类接口可以随时变的, 你象加啥都可以随时加的. <br />
但是formal的interface的定义在python中还是有意义的, 首先是作为documentation, 便于工程师学习和维护代码. 第二是作为一种touchstone, <code>zope.interface</code> module allows you to explicitly declare that a class implements one or more interfaces, and provides mechanisms to examine these declarations at run-time. 第三是作为间接的机制, adaption模式, the ability to dynamically provide a given interface for an object that might not support that interface directly.</p>
<p>下面就来看看, reactor怎样来进行封装的, 从addReader(self)入手,  It is declared in the <a href="http://twistedmatrix.com/trac/browser/tags/releases/twisted-8.2.0/twisted/internet/interfaces.py#L801" rel="external nofollow noreferrer"><code>IReactorFDSet</code></a> Interface, IReactorFDSet is one of the Interfaces that Twisted reactors implement. Thus, any Twisted reactor has a method called <code>addReader</code> that works as described by the docstring above. 这个接口就是用来管理需要侦听的端口集合的, File Description Set, 通过addReader来增加对象(包含端口信息和相关callback)</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<pre>
</pre>
<p>1 def addReader(reader):<br />2     """<br />3     I add reader to the set of file descriptors to get read events for.<br />4     @param reader: An L{IReadDescriptor} provider that will be checked for<br />5                    read events until it is removed from the reactor with<br />6                    L{removeReader}.<br />7     @return: C{None}.<br />8     """</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<p><u>可见在interface中的函数, 和一般的类函数是有不同的, 只有注释段, 并且参数中没有加上self, 其实因为不需要, 没有人会直接实例化interface. <br />
从上面的可知, reader必须要support IReadDescriptor, 对于上面的code就是说self(<strong>PoetrySocket</strong> )必须要support</u></p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<pre>
</pre>
<p>1 IReadDescriptor<br />2 class IReadDescriptor(IFileDescriptor):<br />3  <br />4     def doRead():<br />5         """<br />6         Some data is available for reading on your descriptor.<br />7         """</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<p>And you will find an implementation of <a href="http://github.com/jdavisp3/twisted-intro/blob/master/twisted-client-1/get-poetry.py#L88" rel="external nofollow noreferrer"><code>doRead</code></a> on our <code>PoetrySocket</code> objects. It reads data from the socket asynchronously, whenever it is called by the Twisted reactor. So <code>doRead</code> is really a callback, but instead of passing it directly to Twisted, we pass in an object with a <code>doRead</code> method. This is a <strong>common idiom</strong> in the <strong>Twisted framework</strong> — <strong>instead of passing a function you pass an object that must implement a given Interface</strong> . This allows us to pass a set of related callbacks (the methods defined by the Interface) with a single argument. It also lets the callbacks communicate with each other through shared state stored on the object. <br /><u>上面就比较清楚的解释的Twisted框架的callback机制, 传递包含interface的对象, 而非直接传递函数给reactor. <br />
同时你注意到, IReadDescriptor继承自IFileDescriptor, 所以在<strong>PoetrySocket</strong> 还要实现如connectionLost等函数.</u></p>
<p><u></u></p>
<h2>Part 5: Twistier Poetry</h2>
<h3>Abstract Expressionism</h3>
<p>The Twisted framework is loosely composed of <strong>layers of abstractions</strong> and learning Twisted means learning what those layers provide, i.e, what APIs, Interfaces, and implementations are available for use in each one. <br />
The most important thing to keep in mind when learning a new Twisted abstraction is this:</p>
<p>Most higher-level abstractions in Twisted are built by <em>using</em> lower-level ones, <em>not</em> by replacing them.</p>
<p><u>Twisted框架是由多个抽象层松散组成的, 越底层越容易理解, 但不方便使用, 越高层越方便使用, 但越难理解. 所以学习Twisted还是要从底层学起.  <br />
上一节学习了最底层的abstraction (1.0), 当然这个是有很多问题的, 这节要来介绍更高层一点的抽象 (2.0). <br /></u>Moving to higher-level abstractions generally means <strong>writing less code</strong> (and letting Twisted handle the platform-dependent corner cases).</p>
<h3>Loopiness in the Brain</h3>
<p>The most important abstraction we have learned so far, indeed the most important abstraction in Twisted, is the <strong>reactor</strong> . Much of the rest of Twisted, in fact, can be thought of as “stuff that makes it easier to do X using the reactor” where X might be “serve a web page” or “make a database query” or some other specific feature. <br /><u>在Twisted最重要的抽象就是Reactor, 理解了Reactor就理解了Twisted的精髓, 剩下的模块都是为了使各种任务更容易的使用reactor模式. 在实际使用Twisted时, 由于抽象程度很高, 程序员只要关心真正的callback逻辑, 往往会忽略了Reactor, 这样是无法写出优秀的Twisted代码的. <br /></u>When you choose to use <strong>Twisted</strong> you are also choosing to use the <strong>Reactor Pattern</strong> , and that means programming in the “reactive style” using callbacks and cooperative multi-tasking. If you want to use Twisted correctly, you have to keep the reactor’s existence (and the way it works) in mind.</p>
<p>Before we dive into the code, there are three new abstractions to introduce: Transports, Protocols, and Protocol Factories.</p>
<h4>Transports</h4>
<p>The Transport abstraction is defined by <a href="http://twistedmatrix.com/trac/browser/tags/releases/twisted-8.2.0/twisted/internet/interfaces.py#L1289" rel="external nofollow noreferrer"><code>ITransport</code></a> in the main Twisted <a href="http://twistedmatrix.com/trac/browser/tags/releases/twisted-8.2.0/twisted/internet/interfaces.py" rel="external nofollow noreferrer"><code>interfaces</code></a> module.The Transport abstraction represents any such connection( <a href="http://en.wikipedia.org/wiki/Transmission_Control_Protocol" rel="external nofollow noreferrer">TCP</a> ,  <a href="http://en.wikipedia.org/wiki/Udp" rel="external nofollow noreferrer">UDP</a> sockets,  <a href="http://en.wikipedia.org/wiki/Unix_pipe#Network_pipes" rel="external nofollow noreferrer">UNIX Pipes</a>  ) and handles the details of asynchronous I/O for whatever sort of connection it represents.</p>
<h4>Protocols</h4>
<p>Twisted Protocols are defined by <a href="http://twistedmatrix.com/trac/browser/tags/releases/twisted-8.2.0/twisted/internet/interfaces.py#L1111" rel="external nofollow noreferrer"><code>IProtocol</code></a> in the same <a href="http://twistedmatrix.com/trac/browser/tags/releases/twisted-8.2.0/twisted/internet/interfaces.py" rel="external nofollow noreferrer"><code>interfaces</code></a> module. As you might expect, Protocol objects implement<a href="http://en.wikipedia.org/wiki/Protocol_%28computing%29" rel="external nofollow noreferrer">protocols</a> . That is to say, a particular implementation of a Twisted Protocol should implement one specific networking protocol, like <a href="http://en.wikipedia.org/wiki/File_Transfer_Protocol" rel="external nofollow noreferrer">FTP</a> or <a href="http://en.wikipedia.org/wiki/Internet_Message_Access_Protocol" rel="external nofollow noreferrer">IMAP</a> or some nameless protocol we invent for our own purposes. <br />
Each instance of a Twisted Protocol object implements a protocol for one <em>specific</em> connection. 协议和connection一一对应的, 这个很好理解, 建立connection后, 要指明接受和发送数据的协议是啥.Twisted实现了大量的协议in <a href="http://twistedmatrix.com/trac/browser/tags/releases/twisted-8.2.0/twisted/protocols/basic.py" rel="external nofollow noreferrer"><code>twisted.protocols.basic</code></a> , 所以在编写自己特有的协议前可以去查找一下, 也许有现成的.</p>
<h4>Protocol Factories</h4>
<p>So each connection needs its own Protocol and that Protocol might be an instance of a class we implement ourselves. Since we will let Twisted handle creating the connections, Twisted needs a way to make the appropriate Protocol “on demand” whenever a new connection is made. Making Protocol instances is the job of Protocol Factories.</p>
<p>The Protocol Factory API is defined by <a href="http://twistedmatrix.com/trac/browser/tags/releases/twisted-8.2.0/twisted/internet/interfaces.py#L1259" rel="external nofollow noreferrer">IProtocolFactory</a> , also in the <a href="http://twistedmatrix.com/trac/browser/tags/releases/twisted-8.2.0/twisted/internet/interfaces.py" rel="external nofollow noreferrer"><code>interfaces</code></a> module. Protocol Factories are an example of the <a href="http://en.wikipedia.org/wiki/Factory_pattern" rel="external nofollow noreferrer">Factory</a> design pattern and they work in a straightforward way. The <code>buildProtocol</code> method is supposed to return a new Protocol instance each time it is called. This is the method that Twisted uses to make a new Protocol for each new connection. <br />
用了设计模式的工厂方法, 根据不同的情况为connection生成不同的protocol实例</p>
<h3>Get Poetry 2.0: First Blood.0</h3>
<p>Alright, let's take a look at version 2.0 of the Twisted poetry client.</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<pre>
</pre>
<p>1 class PoetryProtocol(Protocol):<br /> 2     poem = ''<br /> 3     def dataReceived(self, data):<br /> 4         self.poem += data<br /> 5     def connectionLost(self, reason):<br /> 6         self.poemReceived(self.poem)<br /> 7     def poemReceived(self, poem):<br /> 8         self.factory.poem_finished(poem)<br /> 9 class PoetryClientFactory(ClientFactory):<br />10     protocol = PoetryProtocol # tell base class what proto to build<br />11     def __init__(self, poetry_count):<br />12         self.poetry_count = poetry_count<br />13         self.poems = []<br />14     def poem_finished(self, poem=None):<br />15         if poem is not None:<br />16             self.poems.append(poem)<br />17         self.poetry_count -= 1<br />18         if self.poetry_count == 0:<br />19             self.report()<br />20             from twisted.internet import reactor<br />21             reactor.stop()<br />22     def report(self):<br />23         for poem in self.poems:<br />24             print poem<br />25     def clientConnectionFailed(self, connector, reason):<br />26         print 'Failed to connect to:', connector.getDestination()<br />27         self.poem_finished()<br />28 def poetry_main():<br />29     addresses = parse_args()<br />30     factory = PoetryClientFactory(len(addresses))<br />31     from twisted.internet import reactor<br />32     for address in addresses:<br />33         host, port = address<br />34         reactor.connectTCP(host, port, factory)<br />35     reactor.run()</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<p><u>这就是用上面几个新介绍的类实现的更高抽象级别的client, 那么在Twisted中high-level抽象级别的对象是通过调用low-level级别的对象实现的, 所以这边我们就来看看和猜猜, 2.0版本怎么样实现的, 原作者没这样写, 所以下面我写的个人看法, 不一定对.</u></p>
<p><a href="http://images.cnitblog.com/blog/312753/201305/27162439-15c99bb703d349ea982387c854d2a861.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzMxMjc1My8yMDEzMDUvMjcxNjI0MzktMDBhNzBlNjQxNjM4NDA3ZmJmZjY5ZGZhMWI1Mzg2NDUucG5n.jpg"></a></p>
<p><u>首先在2.0版本中已经完全的看不到直接的socket操作, 也没有addReader, removeReader等操作, 其实想想这些code对于每个client而言都是一样的, 是可以重用的, 没有必要每次都写一遍. 真正需要开发者开发的就是那几个callback, 比如doRead, connectionLost <br />
那么作为一个框架的设计者应该怎么做, 把所有公共的东西都封装起来, 只让用户关心他应该关心的code, 让开发者写尽量少的code. 这个就是一种抽象, 抽象层次的提高, 就是把更多的代码写到框架内, 减轻开发者的工作量. <br />
那么框架开发者来写<strong>PoetrySocket</strong> 类, 比如称做connection类, 里面完成connet socket, addReader等common的code, 但它还必须要实现IReadDescriptor的接口, 比如doRead, 这个框架开发者是无法写死的. 怎么办? <br />
所以引入Protocol对象, 把所有和具体业务逻辑相关的callback都封装在Protocol对象里面, 在connection类中只需要调用对应protocol对象的固定接口. <br />
如上图, socket ready --&gt; reader.doRead() --&gt; protocol.dataReceived(), 通过调用protocol.dataReceived()来完成真正的处理工作. <br />
这样connection类就变成完全common的类, 可以放到框架中, 而对应用开发者完全透明. <br />
其实还差一步, 现在的connection类还不是完全common的类, 为什么? <br />
问题在于, 生成Protocol对象, 使用前必须要创建对象, 而对于不同的情况需要创建的protocol对象明显是不同的. <br />
如果你在connection类直接写, new PoetryProtocol(), 那么这块code就需要每次修改以变换protocol名. <br />
针对这个问题, 典型的设计模式是工厂方法, 把具体创建对象的过程封装在工厂类里面, 而在真正需要创建对象的地方使用工厂类的统一接口, 如Factory.buildProtocol() <br />
而具体开发者, 需要提供相应protocol的工厂类来用于实现对象创建.  <br />
好, 到这一步, 就算是完成了对connection类的封装. <br />
现在我们再来看这段代码, 就很清楚了, 首先开发者需要定义protocol类和工厂类. <br />
接着开发者需要编写的代码只有这么一句, reactor.connectTCP(host, port, factory) <br />
看似简单, 其实内涵丰富, 远远不止名字所表明的connectTCP, 应该包括如下活动(我猜的)  <br />
1. 通过factory创建protocol对象 <br />
2. 创建支持IReadDescriptor的连接对象, 并通过调用protocol来实现callback, 如doRead <br />
3. 建立socket连接, 这里会通过抽象的transport对象来实现, 而不会直接使用socket <br />
4. 通过addReader把这个连接对象加到侦听队列</u></p>
<p><u><br /></u></p>
<p><u>本文章摘自博客园，原文发布日期：2011-07-05<br /></u></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 05:48:07</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/socket/" title="socket">socket</a>, <a href="https://www.iamivan.net/tag/code/" title="code">code</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>An Introduction to Asynchronous Programming and Twisted (1)的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boK5W3b.html" rel="bookmark">An Introduction to Asynchronous Programming and Twisted &lpar;2&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Part 6: And Then We Took It Higher Part5中的client2.0, 在封装性上已经做的不错, 用户只需要了解和修改PoetryProtocol, PoetryClientFactory就可以完成一个应用. 其实此处, protocol的逻辑就是接受数据, 接受完以后通知factory处理, 这段逻辑已经可以作为common的框架代码, 用户无需改动. 真正需要用户每次根据上下文修改的是, 当数据接受完后的处理逻辑poem_finished(print? sa			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MydQYvb.html" rel="bookmark">An Introduction to Asynchronous Programming and Twisted &lpar;3&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Part 11: Your Poetry is Served A Twisted Poetry Server Now that we've learned so much about writing clients with Twisted, let's turn around and re-implement our poetry server with Twisted too. And thanks to the generality of Twisted's abstractions, i			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p56O9Rz.html" rel="bookmark">An Introduction to Interactive Programming in Python &lpar;Part 1&rpar; -- Week 2&lowbar;1 练习</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				# Practice Exercises for Functions # Solve each of the practice exercises below. # 1.Write a Python function miles_to_feet that takes a parameter miles and # returns the number of feet in miles miles. def miles_to_feet(miles): feet = miles * 5280 ret			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvEqL9b.html" rel="bookmark">An Introduction to Interactive Programming in Python &lpar;Part 1&rpar; -- Week 2&lowbar;3 练习</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Mini-project description - Rock-paper-scissors-lizard-Spock Rock-paper-scissors is a hand game that is played by two people. The players count to three in unison and simultaneously &quot;throw&quot; one of three hand signals that correspond to rock, paper			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pL2JZWb.html" rel="bookmark">An Introduction to Interactive Programming in Python &lpar;Part 1&rpar; -- Week 2&lowbar;2 练习</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				#Practice Exercises for Logic and Conditionals # Solve each of the practice exercises below. # 1.Write a Python function is_even that takes as input the parameter number (an integer) and # returns True if number is even and False if number is odd. #			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/9MxjWPz.html" rel="bookmark">网页前端设计资源&colon;前端设计资源收藏夹</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				文章简介:今天在邮件中收到一个由 Dimi Navrotskyy在Github上发布的前端收藏夹,里面的资源太丰富了.我在想很多同学肯定喜欢.本想直接发个链接与大家分享,但时间久了,找起来辛苦.特意copy了一份发在w3cplus上. 今天在邮件中收到一个由 Dimi Navrotskyy在Github上发布的前端收藏夹,里面的资源太丰富了.我在想很多同学肯定喜欢.本想直接发个链接与大家分享,但时间久了,找起来辛苦.特意copy了一份发在w3cplus上.而且我在后面还增加了一份我自己整理的学习			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3272wz.html" rel="bookmark">iOS 各版本中的新特性（What&amp;amp&semi;&num;39&semi;s New in iOS）- 目录翻译完成</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				iOS 各版本中的新特性(What's New in iOS) 太阳火神的美丽人生 (http://blog.csdn.net/opengl_es) 本文遵循&quot;署名-非商业用途-保持一致&quot;创作公用协议 转载请保留此句:太阳火神的美丽人生 -  本博客专注于 敏捷开发及移动和物联设备研究:iOS.Android.Html5.Arduino.pcDuino,否则,出自本博客的文章拒绝转载或再转载,谢谢合作. 介绍 Introduction文档组织结构 Organization of Thi			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlOX0Yb.html" rel="bookmark">学习 NodeJS 第六天：主程 Ry 访谈录</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这是一段 Oleg Podsechin 与 NodeJS 主程序员 Ryan Dahl 之间的访谈录.虽然不是 NodeJS 的教程,但是从访谈之中可以看出关于 NodeJS 的一些情况,帮助我们理解 NodeJS 之所以存在的前因后果.                                                                                                                                   			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlOkVVb.html" rel="bookmark">A simple IOCP Server&sol;Client Class</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  Download demo project v1.13 - 64.4 Kb Download source v1.13 - 121 Kb 1.1 Requirements This article expects the reader to be familiar with C++, TCP/IP, socket programming, MFC, and multithreading. The source code uses Winsock 2.0 and IOCP technology			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OM91voM.html" rel="bookmark" class="title">c语言编程-求短时傅立叶程序，用c编写的！</a>
					<div>
						问题描述 求短时傅立叶程序,用c编写的! 哪位有短时傅立叶,傅立叶,傅立叶反变换的c语言程序,求大神帮忙! 解决方案 这种代码很复杂,一般写出来的都不愿意随便分享的! 解决方案二: 有大神愿意分享的吗 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7M0O3Jb.html" rel="bookmark" class="title">ASP视频教程&colon;备份和还原SQL Server 2000数据库</a>
					<div>
						大家在初学ASP程序的时候,我们经常第一个任务就是配置环境!在这里根据网页教学网站长的经验,有时克隆版的XP系统有时是安装不了IIS的!前面我们已经讲解了ASP视频教程:制作网站前台首页,本讲主要讲述 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XpmYKBp.html" rel="bookmark" class="title">关于php缓存技术的总结</a>
					<div>
						1.全页面静态化缓存 也就是将页面全部生成html静态页面,用户访问时直接访问的静态页面,而不会去走php服务器解析的流程.此种方式,在CMS系 统中比较常见,比如dedecms: 一种比较常用的实现 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0boo4Bb.html" rel="bookmark" class="title">php printf输出格式使用说明</a>
					<div>
						printf的格式控制的完整格式: % - 0 m.n l或h 格式字符 下面对组成格式说明的各项加以说明: ①%:表示格式说明的起始符号,不可缺少. ②-:有-表示左对齐输出,如省略表示右对齐输出. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMq3Kkz.html" rel="bookmark" class="title">&period;Net平台Windows Forms程序设计简介-1</a>
					<div>
						引言: 微软的.Net平台堪称为新一代的互联网平台.对于技术开发人员来说,.Net平台的两大特性是非常卓越的,首先是其所提供的公共语言运行时,也就是公用语言运行平台,另一方面就是庞大而全面的统一编程类 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/jbE1v6b.html" rel="bookmark" class="title">android FragmentTabhost实现选项卡</a>
					<div>
						在Android3.0之后,google创造了Fragment,因此原来的Tabhost已经不推荐使用了,现在一般推荐使用FragmentTabhost. google考虑到了兼容问题,因此Fragm ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lpdwk1M.html" rel="bookmark" class="title">实现窗体的自动隐藏显示功能</a>
					<div>
						现在许多程序的窗体都有自动隐藏/显示的功能(比如OICQ). 实现这样的功能其实很简单,原理是:判断鼠标是否移到了屏幕的最左边或最右边,如果移到了则显示窗体,如果鼠标移开了窗体则隐藏窗体.在本程序中, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNE7qob.html" rel="bookmark" class="title">如何设置无线路由器实现有线和无线宽带接入</a>
					<div>
						霍大哥家买了台IBM笔记本,家里有联想品牌台式机,两台PC机,总想共享一条线路上网.笔记本携带方便用无线上网方式,台式机本身不带无线网卡,所以用有线上网方式.由于他本人对这个上网方式有点不特理解,请我 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLOQB5M.html" rel="bookmark" class="title">在ASP&period;NET中使用Memcached</a>
					<div>
						现在一些.NET开发人员开始放弃ASP.NET内置的缓存机制,转而使用Memcached--一种分布式的内存缓存系统,其最初是由Danga Interactive公司为LiveJournal网站而开发 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4wxY8p.html" rel="bookmark" class="title">win7系统怎么设置和调试游戏手柄</a>
					<div>
						  win7系统怎么设置和调试游戏手柄 1.首先在电脑主机上插入手柄,等电脑自己装好驱动之后,在[开始]菜单,选择[设备和打印机]进行设置; 2.打开[设备和打印机]之后选择电脑已连接的游戏手柄的图标 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M62rAOM.html" rel="bookmark" class="title">PS简单方法制作红外线效果的照片处理教程</a>
					<div>
						原图 效果 1. 打开图片,对人物进行磨皮,美白处理(图的质量好,这一步我省略)转CMYK模式. 2. 可选颜色绿(-100 -100 100)做2次.可以加蒙板擦出人物和花. 3.可选颜色黄(-10 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1ElrjM.html" rel="bookmark" class="title">笔记本如何使用内置Wi-Fi共享功能</a>
					<div>
						  以三星笔记本自带的&quot;三星设置中心&quot;为例,在&quot;网络&quot;选项卡的&quot;移动热点&quot;设置界面,打开&quot;将我的设备用作Internet AP(接 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9EvLkM.html" rel="bookmark" class="title">PS好莱坞电影海报教程之《红色机尾》</a>
					<div>
						  最终效果图: 注:教程重在思路,素材同学们找自己喜欢的就行咯. 新建一个宽1000,高1480,72分辨率的新画布. 置入一张鸟瞰城市图. 旋转一下,让地平线倾斜一点使画面更具动感,我旋转了20. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6eBKAb.html" rel="bookmark" class="title">Macbook蝴蝶键盘&sol;蝶式结构键盘解析</a>
					<div>
						  新苹果笔记本Macbook蝴蝶键盘与普通键盘有什么不一样了?在刚刚过去的苹果发布会上,苹果重点为大家介绍了自家的Macbook蝴蝶键盘/蝶式结构键盘,来看一下这个新式的键盘到底有什么不一样吧. M ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z72DQRp.html" rel="bookmark" class="title">恢复被删除的文档</a>
					<div>
						  由于一些原因,用户在操作电脑的时候,很容易将文档误删,而且也清空了回收站,造成数据丢失.这时,可以使用专业的软件来找回文档. FinalData就是一个文件恢复的程序,可以利用它来找回被删除的文档 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MArNaXp.html" rel="bookmark" class="title">Go语言的9大优势和3大缺点</a>
					<div>
						转用一门新语言通常是一项大决策,尤其是当你的团队成员中只有一个使用过它时.今年 Stream 团队的主要编程语言从 Python 转向了 Go.本文解释了其背后的九大原因以及如何做好这一转换. Go的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg3vPmM.html" rel="bookmark" class="title">手把手玩转win8开发系列课程（1）</a>
					<div>
						win8操作系统推出一个多月了,我做win8开发也有2个多月了,也写了不少wi8开发的游戏开发的博文(这一系列我会继续的更新),在这里我准备重新推出一套win8的手把手的教程,来帮助更多人,走入win ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0WJm0b.html" rel="bookmark" class="title">php将文本文件转换csv输出的方法&lowbar;php技巧</a>
					<div>
						本文实例讲述了php将文本文件转换csv输出的方法.分享给大家供大家参考.具体实现方法如下: 这个类提供了转换成固定宽度的CSV文件,快速,简便的方法,它可将SplFileObject用于执行迭代,使 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b24g0vp.html" rel="bookmark" class="title">iis内网程序想用https访问，ssl证书怎么弄</a>
					<div>
						问题描述 iis内网程序想用https访问,ssl证书怎么弄 程序部署在内网iis服务器上,与外网物理隔离,内网只能通过ip地址访问,没有dns服务器,怎么用h?ttps访问? 解决方案 https一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDY2yKb.html" rel="bookmark" class="title">c c&plus;&plus;-我想问一下有关c&sol;c&plus;&plus;的问题</a>
					<div>
						问题描述 我想问一下有关c/c++的问题 string s=&quot;&quot;abc&quot;&quot;;char *a[2]...................怎么将sring类型转化成 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z42qNJM.html" rel="bookmark" class="title">采用zookeeper的EPHEMERAL节点机制实现服务集群的陷阱</a>
					<div>
						在apush的集群管理中使用了zk的EPHEMERAL节点机制. 在编码过程中发现很多可能存在的陷阱,毛估估,第一次使用zk来实现集群管理的人应该有80%以上会掉坑,有些坑比较隐蔽,在网络问题或者异常 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlQw2np.html" rel="bookmark" class="title">本以为灰指甲已经治好，没想到停药后更加严重</a>
					<div>
						本以为灰指甲已经治好,没想到停药后更加严重 5年前,夏先生感染了灰指甲,2011年底他选择哈尔滨乐泰药业的&quot;亮甲&quot;进行治疗.经过一年多的治疗,花费了一万多元,灰指甲终于没了,夏先生 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8kqwoM.html" rel="bookmark" class="title">有需要经典视频教程的请看看</a>
					<div>
						问题描述 您选择浪曦的理由:一.一流师资,更专业更权威,保证教材质量,紧跟热门技术趋势张龙(java.netweb领域):同济大学软件工程硕士,曾在上海交大慧科南洋计算机教育中心.北京英泰移动通信有限 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6NWXyM.html" rel="bookmark" class="title">浏览器调接口-浏览器怎么访问webservice接口</a>
					<div>
						问题描述 浏览器怎么访问webservice接口 求大神告知 浏览器怎么访问webservice接口,在线等.............. 解决方案 不是很明白, 你浏览器通过http,在地址栏输入你的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB1WKJz.html" rel="bookmark" class="title">互联网大陆的守夜人：信息加密技术</a>
					<div>
						  互联网黄金时代的到来,让人们享受到了各种各样的便利,最大的功臣当然是计算机软硬件以及互联网通信技术的飞速发展,当然背后也有一些默默奉献的无名者,今天的文章的便是关于其中一位,我把它比喻为互联网大陆 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwW2Lkz.html" rel="bookmark" class="title">html-HTML中如何使用一个绝对路径显示一张图片？</a>
					<div>
						问题描述 HTML中如何使用一个绝对路径显示一张图片? 为了项目以后的更新,所以将图片的存储位置放到了工程外面,这样在显示图片的时候必须用绝对路径了..求教! 解决方案 JSP 页面中用绝对路径显示图 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQjkN0M.html" rel="bookmark" class="title">如何用变量后缀名循环的方式把每一个变量的值 msgbox 出来</a>
					<div>
						问题描述 VB.NET中publicUser1,User2,User3,User4asstringUser1=&quot;A&quot;User2=&quot;B&quot;User3=&quot;C ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZBkGaz.html" rel="bookmark" class="title">发布Cognos服务，启动时报DPR-ERR-2058错误</a>
					<div>
						问题描述 请教大家,在Websphere上发布Cognos服务,启动时报DPR-ERR-2058错误,是什么原因啊?					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlLDORM.html" rel="bookmark" class="title">Oracle ROWID 方式访问数据库</a>
					<div>
						    和ROWNUM一样,ROWID是一个伪列,即是一个非用户定义的列,而又实际存储于数据库之中.每一个表都有一个ROWID列,一个ROWID值用于唯一确定数据库表中的的一条记录.因此通过ROWID ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOJOlmp.html" rel="bookmark" class="title">wpf 如何获取datagridcell 我需要动态改变单元格的背景</a>
					<div>
						问题描述 wpf 如何获取datagridcell 我需要动态改变单元格的背景 根据条件动态改变单元格背景或者字体.已经获取到行,但是调试了很久不知道如何锁定到某个单元格... for (int i  ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.056 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
